Subject: Re: [PATCH net-next v2] test_bpf: add similarly conflicting jump test case only for classic

From: Alexei Starovoitov <[email-masked]>
Date: Tue, 26 May 2015 13:43:26 -0700

On 5/26/15 1:35 PM, Daniel Borkmann wrote:
> While 3b52960266a3 ("test_bpf: add more eBPF jump torture cases")
> added the int3 bug test case only for eBPF, which needs exactly 11
> passes to converge, here's a version for classic BPF with 11 passes,
> and one that would need 70 passes on x86_64 to actually converge for
> being successfully JITed. Effectively, all jumps are being optimized
> out resulting in a JIT image of just 89 bytes (from originally max
> BPF insns), only returning K.
>
> Might be useful as a receipe for folks wanting to craft a test case
> when backporting the fix in commit 3f7352bf21f8 ("x86: bpf_jit: fix
> compilation of large bpf programs") while not having eBPF. The 2nd
> one is delegated to the interpreter as the last pass still results
> in shrinking, in other words, this one won't be JITed on x86_64.
>
> Signed-off-by: Daniel Borkmann <[email-masked]>

great tests. Thanks!
Acked-by: Alexei Starovoitov <[email-masked]>